]> git.pld-linux.org Git - packages/rpm-pld-macros.git/blob - macros.pld
3eddc3ecfb743efc09d4cf5f0a50649c41f0f068
[packages/rpm-pld-macros.git] / macros.pld
1 # vim:ts=4 sw=4 noet ft=spec
2 #
3 # PLD Linux rpm macros.
4 # <http://www.pld-linux.org/>
5
6 # can be used by builder script to check for version
7 %rpm_build_macros       {Revision}
8
9 %epoch          0
10 %x8664          x86_64 amd64 ia32e
11
12 # compiler version
13 %cc_version     %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
14 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
15
16 %__rm           /bin/rm --interactive=never
17
18 # Build system path macros.
19 %__autoconf     autoconf %{?debug:-Wall}
20 %__automake     automake -a -c -f --foreign
21 %__autopoint    autopoint --force
22
23 # add parallel build flags: -jN
24 # jobs macro is available since 1.657
25 #
26 # if you want to disable parallel build do:
27 # echo '%__jobs %{nil}' >> ~/.rpmmacros
28 %__jobs         %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
29
30 # expands to -jN if %__jobs has a value
31 %_smp_mflags    %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
32
33 %__make         /usr/bin/make %{?_make_opts} %{?_smp_mflags}
34 %__scons        /usr/bin/scons %{?_smp_mflags}
35 %__waf          /usr/bin/waf %{?_smp_mflags}
36 %__cmake        /usr/bin/cmake -Wno-dev
37 %__meson        /usr/bin/meson
38 %__meson_wrap_mode      nodownload
39 %__ninja        /usr/bin/ninja
40 %__ninja_common_opts    -v %{?_smp_mflags}
41
42 %__gettextize { \
43         gettextize --copy --force --no-changelog; \
44         if [ ! -f po/Makevars ]; then \
45                 cp -f po/Makevars{.template,}; \
46         fi; \
47 }
48
49 %__glib_gettextize      glib-gettextize --copy --force
50 %__gnome_doc_common     gnome-doc-common --copy
51 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
52 %__gtkdocize            gtkdocize --copy
53 %__intltoolize          intltoolize --copy --force
54 %__libtoolize           libtoolize --copy --force --install
55
56 # topdir is where builder script lives,
57 # fallback to old style if SPECS/SOURCES dirs were found.
58 %_topdir    %{expand:%%global _topdir %(
59         if [ -d SPECS -a -d SOURCES ]; then
60                 # old style rpmdir: in topdir
61                 pwd
62         elif [ -d ../SPECS -a -d ../SOURCES ]; then
63                 # old style rpmdir: in subdir
64                 cd ..; pwd
65         elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
66                 # if old style rpm dir exist, go with it
67                 echo $HOME/rpm; \
68         elif [ -x ../builder -a ! -d ../builder ]; then
69                 # relative new style rpmdir: in package dir
70                 cd ..; pwd
71         elif [ -x builder -a ! -d builder ]; then
72                 # relative new style rpmdir: in packages
73                 pwd
74         elif [ -x packages/builder -a ! -d packages/builder ]; then
75                 # relative new style rpmdir: packages dir in current dir
76                 cd packages; pwd
77         else
78                 # fallback to new style rpmdir
79                 echo $HOME/rpm/packages
80         fi; \
81 )}%_topdir
82
83 # if %{_topdir}/SPECS exists, it's old style structure
84 %_specdir               %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
85 %_sourcedir             %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
86
87 # BUILD/RPMS/SRPMS are on same level by default as packages dir, if these exist
88 # if they don't exist assume we are having custom topdir (which is not named as
89 # "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
90 # NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therefore the extra echo
91 %_builddir              %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
92 %_rpmdir                %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
93 %_srcrpmdir             %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
94
95 #       The number of cvs changelog entries kept when building package.
96 %_buildchangelogtruncate 20
97
98 %dependencytracking     %{nil}
99
100 #       Relations between package names that cause dependency loops
101 #       with legacy packages that cannot be fixed. Relations are
102 #       specified as
103 #               p>q
104 #       where package p has a Requires: on something that package q Provides:
105 #
106 # XXX   Note: that there cannot be any whitespace within the string "p>q",
107 #       and that both p and q are package names (i.e. no version/release).
108 %_dependency_whiteout   %{nil}
109
110 #-----------------------------------------------------------------
111 #
112 # (re)definition of %{rpm*flags} with %filterout_* support
113 # BuildRequires:        awk
114 # BuildRequires:        rpmbuild(macros) >= 1.315
115 #
116 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
117 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
118 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
119 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
120 # %rpmldflags   = %optldflags - %filterout_ld
121 #
122 # Regular expressions are supported, but to avoid some character be treated
123 # as regular expression it must be escaped twice.
124
125 %filter_out                                                     \
126         for (i = 1; i in I; i++) { A=0; \
127                 for (f in F) {                          \
128                         if (I[i] ~ "^" F[f] "$") A=1;   \
129                 };                                                      \
130                 if (!A) printf(I[i] FS);        \
131         }
132
133 %rpmcflags %(awk 'BEGIN {
134         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
135         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
136         %{filter_out}
137 }')
138
139 %rpmcxxflags %(awk 'BEGIN {
140         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
141         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
142         %{filter_out}
143 }')
144
145 %rpmcppflags %(awk 'BEGIN {
146         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
147         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
148         %{filter_out}
149 }')
150
151 %rpmldflags %(awk 'BEGIN {
152         split("%{?optldflags}",I);
153         split("%{?filterout_ld}",F)
154         %{filter_out}
155 }')
156
157 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
158 # but, don't use it, better use gcc as linker
159 %ld_rpmldflags %(awk 'BEGIN {
160         split("%{rpmldflags}",F);
161         for (f in F) {
162                 s = F[f];
163                 if (s ~ /^-Wl,/) {
164                         s = substr(s,5);
165                         gsub(/,/," ",s);
166                 };
167                 printf(s FS);
168         };
169 }')
170
171 #-----------------------------------------------------------------
172 #
173 #  Generate a command which cleans environment, leaving only the
174 # most important variables.
175 #  If any spec requires any additional environment it should
176 # redefine %_preserve_env in following manner:
177 #
178 #       # ADDITIONAL_VAR is required because [a good reason here]
179 #       %define _preserve_env ADDITIONAL_VAR
180
181 %_preserve_env_base     PATH HOME TMP TMPDIR SSH_AUTH_SOCK
182
183 # "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
184 %_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
185         split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
186         for (i in P) {
187                 p = P[i];
188                 if (!ENVIRON[p] || d[p]) {
189                         continue;
190                 }
191                 d[p] = 1;
192                 split(ENVIRON[p], V, "");
193                 val = p "=";
194                 for (j = 1; j in V; j++) {
195                         v = V[j];
196                         if (v == q)
197                                 v = qq;
198                         else if (v == "\\"")
199                                 v = q2q;
200                         else if (v == "\\\\")
201                                 v = "\\\\\\\\";
202                         else
203                                 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
204                         val = val "" v;
205                 }
206                 printf(val " ");
207         }
208 }')
209
210 # override %__spec_build_pre and %__spec_install_pre from macros.rpmbuild
211 # adding %{_clean_env}
212 %__spec_build_pre       %{_clean_env}\
213 %{___build_pre}\
214 %{nil}
215 %__spec_install_pre     %{_clean_env}\
216 %{___build_pre}\
217 %{?buildroot:%{__rm} -rf '%{buildroot}'; %{__mkdir_p} '%{buildroot}'}\
218 %{nil}
219
220 #-----------------------------------------------------------------
221 %configure2_13 { \
222  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
223  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
224  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
225  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
226  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
227  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
228  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
229  %{?__cc:CC="%{__cc}" ; export CC ; } \
230  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
231  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
232         --host=%{_target_platform} \
233         --prefix=%{_prefix} \
234         --exec-prefix=%{_exec_prefix} \
235         --bindir=%{_bindir} \
236         --sbindir=%{_sbindir} \
237         --sysconfdir=%{_sysconfdir} \
238         --datadir=%{_datadir} \
239         --includedir=%{_includedir} \
240         --libdir=%{_libdir} \
241         --libexecdir=%{_libexecdir} \
242         --localstatedir=%{_localstatedir} \
243         --sharedstatedir=%{_sharedstatedir} \
244         --mandir=%{_mandir} \
245         --infodir=%{_infodir} \
246         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
247         %{dependencytracking} \
248 }
249
250 # Note: pass only standard cmake macros here.
251 # The only exception is SYSCONF_INSTALL_DIR, used commonly in KDE packages,
252 # where the default (${CMAKE_INSTALL_PREFIX}/etc) is not FHS-compliant and
253 # absolute path MUST be used to comply with FHS.
254 # The other non-standard cmake macros used commonly in KDE
255 # (INCLUDE_INSTALL_DIR, LIB_INSTALL_DIR, SHARE_INSTALL_PREFIX)
256 # have sane default values in KDE, and some packages use these names
257 # in different way (e.g. expect them to be always relative or always
258 # absolute).
259 %cmake \
260 %{?__cc:CC="${CC:-%{__cc}}"} \\\
261 %{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
262 CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
263 %{__cmake} \\\
264         -DCMAKE_VERBOSE_MAKEFILE=ON \\\
265         -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
266         -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \\\
267         -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \\\
268         -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \\\
269         -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
270         -DCMAKE_INSTALL_SHAREDSTATEDIRPATH:PATH=%{_sharedstatedir} \\\
271         -DCMAKE_INSTALL_LOCALSTATEDIRPATH:PATH=%{_localstatedir} \\\
272         -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
273         -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \\\
274         -DCMAKE_INSTALL_OLDINCLUDEDIR:PATH=%{_includedir} \\\
275         -DCMAKE_INSTALL_DATAROOTDIR:PATH=%{_datadir} \\\
276         -DCMAKE_INSTALL_DATADIR:PATH=%{_datadir} \\\
277         -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \\\
278         -DCMAKE_INSTALL_LOCALEDIR:PATH=%{_localedir} \\\
279         -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \\\
280         -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir} \\\
281         -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
282         -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
283         -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
284         -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
285         -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
286         -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
287         -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
288         -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
289 %if "%{_lib}" == "lib64" \
290         -DLIB_SUFFIX=64 \\\
291 %endif \
292 %if "%{_lib}" == "libx32" \
293         -DLIB_SUFFIX=x32 \\\
294 %endif \
295         -DBUILD_SHARED_LIBS:BOOL=ON \\\
296 %{nil}
297
298 %scons { \
299 %{__scons} \
300         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
301         CFLAGS="${CFLAGS:-%rpmcflags}" \
302         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
303         FFLAGS="${FFLAGS:-%rpmcflags}" \
304         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
305         %{?__cc:CC="%{__cc}"} \
306         %{?__cxx:CXX="%{__cxx}"} \
307         libsuffix=%{_lib} \
308         prefix=%{_prefix} \
309 }
310
311 # waf. see waf.spec
312 %waf { \
313 CC="%{__cc}" \
314 CXX="%{__cxx}" \
315 CPP="%{__cpp}" \
316 CFLAGS="%{rpmcflags}" \
317 CXXFLAGS="%{rpmcxxflags}" \
318 LINKFLAGS="%{rpmldflags}" \
319 %{__waf} \
320 }
321
322 # meson
323 %meson { \
324 %{?__cc:CC="${CC:-%{__cc}}"} \
325 %{?__cxx:CXX="${CXX:-%{__cxx}}"} \
326 CFLAGS="${CFLAGS:-%{rpmcflags}}" \
327 CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \
328 CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \
329 LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \
330 LC_ALL=C.UTF-8 %{__meson} \
331         --buildtype=plain \
332         --bindir=%{_bindir} \
333         --datadir=%{_datadir} \
334         --includedir=%{_includedir} \
335         --infodir=%{_infodir} \
336         --libdir=%{_libdir} \
337         --libexecdir=%{_libexecdir} \
338         --localedir=%{_localedir} \
339         --localstatedir=%{_localstatedir} \
340         --mandir=%{_mandir} \
341         --prefix=%{_prefix} \
342         --sbindir=%{_sbindir} \
343         --sharedstatedir=%{_sharedstatedir} \
344         --sysconfdir=%{_sysconfdir} \
345         --wrap-mode=%{__meson_wrap_mode} \
346         --default-library='both' \
347 }
348
349 %___meson_deprecate() {echo >&2 "DEPRECATED: %%%1 must be replaced with %%%2"; %{expand:%%%2} }
350 %meson_build %___meson_deprecate meson_build ninja_build
351 %meson_install %___meson_deprecate meson_install ninja_install
352 %meson_test %___meson_deprecate meson_test ninja_test
353
354 # ninja
355 %ninja_build LC_ALL=C.UTF-8 %{__ninja} %{__ninja_common_opts}
356 %ninja_install LC_ALL=C.UTF-8 DESTDIR=%{buildroot} %{__ninja} install %{__ninja_common_opts}
357 %ninja_test LC_ALL=C.UTF-8 %{__ninja} test %{__ninja_common_opts}
358
359 #----------------------------------------------------------------
360 #%configure_cache 0
361 %configure_cache_file   %{buildroot}.configure.cache
362
363 %configure {./configure \
364         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
365         CFLAGS="${CFLAGS:-%rpmcflags}" \
366         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
367         FFLAGS="${FFLAGS:-%rpmcflags}" \
368         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
369         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
370         %{?__cc:CC="%{__cc}"} \
371         %{?__cxx:CXX="%{__cxx}"} \
372         --host=%{_target_platform} \
373         --build=%{_target_platform} \
374         --prefix=%{_prefix} \
375         --exec-prefix=%{_exec_prefix} \
376         --bindir=%{_bindir} \
377         --sbindir=%{_sbindir} \
378         --sysconfdir=%{_sysconfdir} \
379         --datadir=%{_datadir} \
380         --includedir=%{_includedir} \
381         --libdir=%{_libdir} \
382         --libexecdir=%{_libexecdir} \
383         --localstatedir=%{_localstatedir} \
384         --sharedstatedir=%{_sharedstatedir} \
385         --mandir=%{_mandir} \
386         --infodir=%{_infodir} \
387         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
388         %{dependencytracking} \
389         %{?configure_cache:--cache-file=%{configure_cache_file}} \
390 }
391
392 # Simple macros to simplify adding bconded options to configure scripts.
393 #   Each macro requires bcond name and accepts optional option name, if option
394 # isn't specified bcond name is used as option name. Options returning
395 # --with and --enable also allow third argument which will be added as value
396 # ( --with-option=value or --enable-option=value ) in case or positive
397 # condition, but won't be added otherwise ( nothing or just --disable-option ).
398
399 # Requirements:
400 # BuildRequires: rpmbuild(macros) >= 1.527
401
402 # Usage example:
403 # %{__enable bcond} - returns --enable-bcond iff build condition is set
404 # %{__disable bcond option} - returns --enable-option iff bcond is not set
405 # %{__enable_disable bcond option value} - returns --enable-option=value if
406 #    bcond is set, returns --disable-option otherwise
407
408 # expand bconds to --enable-something and --disable-something
409 %__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
410 %__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
411 %__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
412
413 # same as above, but condition inverted
414 %__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
415 %__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
416 %__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
417
418 # expand bconds to --with-something and --without-something
419 %__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
420 %__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
421 %__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
422
423 # same as above, but condition inverted
424 %__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
425 %__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
426 %__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
427
428 # expands to true or false based on bcond; for use with meson or cmake
429 %__true_false() %{expand:%%{?with_%{1}:true}%%{!?with_%{1}:false}}
430 %__true_false_not() %{expand:%%{?with_%{1}:false}%%{!?with_%{1}:true}}
431
432 # for use with cmake:
433 # Usage: cmake_on_off BCOND_NAME [OPTION_NAME]
434 # BuildRequires: rpmbuild(macros) >= 1.742
435 %cmake_on_off() -D%{?2}%{!?2:%{1}}:BOOL=%{expand:%%{?with_%{1}:ON}%%{!?with_%{1}:OFF}}
436
437 #-----------------------------------------------------------------
438
439 # overload to insert debuginfo package
440 %prep \
441 %if 0%{?_enable_debug_packages}\
442 %{debug_package}\
443 %endif\
444 %%prep\
445 %{nil}
446
447 # Location of autoconf macros
448 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
449
450 # Location of omf files
451 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
452
453 # Location of pkgconfig files
454 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
455 # noarch pkgconfig files
456 %_npkgconfigdir /usr/share/pkgconfig
457
458 # Location of desktop files
459 %_desktopdir    /usr/share/applications
460 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
461
462 # Location of pixmaps for applnk/desktop files
463 %_pixmapsdir    /usr/share/pixmaps
464
465 # Location of themable icons for applnk/desktop files
466 %_iconsdir      /usr/share/icons
467
468 # Location of fonts directories
469 %_fontsdir      /usr/share/fonts
470
471 # Location of Gtk and associated libraries documentation
472 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
473
474 # Location of KDE documentation
475 %_kdedocdir     %{_defaultdocdir}/kde/HTML
476
477 # unsermake script
478 %__unsermake /usr/share/unsermake/unsermake
479
480 # Current date
481 %date           %(LC_ALL=C date +"%a %b %d %Y")
482
483 # Example files, programs, scripts...
484 %_examplesdir   /usr/src/examples
485
486 # SysV-style initscripts dir
487 %_initddir              /etc/rc.d/init.d
488
489 # If non-empty "debug" macro defined, add "dbg" suffix to release number
490 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
491
492 # Bootstrap release macros.
493 # Usage:
494 #       %bcond_with     bootstrap
495 #       Release:        %{bootstrap_release 1}
496 #
497 # Package will have release 1 if built normally,
498 # and release 0.zzz.bootstrap if built with bootstrap
499 %bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
500
501 # Requires name = version-release
502 %requires_releq()       %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
503 # Requires: name = version
504 %requires_eq()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
505 # Requires: name = version (version based on querying package %2)
506 %requires_eq_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
507
508 # Requires: name >= version
509 %requires_ge()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
510 # Requires: name >= version (version based on querying package %2)
511 %requires_ge_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
512
513 # helper for renaming packages
514 # %rename old-package
515 %rename() \
516 Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
517 Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
518
519 # for package versions comparison (incl. cc_version or _rpmversion)
520 # BuildRequires:        rpmbuild(macros) >= 1.748
521 %_ver_lt()      %(test rpmvercmp "%{1}" "%{2}" >/dev/null 2>&1 -eq 2; echo $?)
522 %_ver_ge()      !%(test rpmvercmp "%{1}" "%{2}" >/dev/null 2>&1 -eq 2; echo $?)
523
524 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
525
526 # sgml macros
527 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
528 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
529 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
530 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
531 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
532 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
533 %docbook_sgmlcat_fix() { for l in \
534 '' \
535 '  -- default decl --' \
536 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
537 '  -- hacks for opensp --' \
538 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
539 'SYSTEM   "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
540 '' \
541 ; do echo $l; done >> %1 \
542 }
543
544 # vim - "
545
546 # minimum file size needed for compressed documents.
547 # just smaller files than this get larger when compressed.
548 # some stats:
549 # - 0 byte file compressed was 25 bytes .gz
550 # - 39 byte file was compressed as 57
551 # - with test/test.spec@man 158 byte file was compressed also 158
552 %_min_compress_bytes    159
553
554 #-----------------------------------------------------------------
555 # find and gzip all files in %{_mandir} and %{infodir}
556 #
557 # Requires: xargs, find
558 #
559 #%no_install_post_compress_docs 1
560 %__spec_install_post_compress_docs { \
561 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
562         %{!?debug:set +x;} \
563         for i in /usr/share/man /usr/X11R6/man; do \
564                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
565                         echo "Compress man pages: $i"; \
566                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
567                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
568                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
569                                 m=$(readlink "$a"); \
570                                 if [[ "$m" = */* ]]; then \
571                                         # handle links to different man section \
572                                         l=$(readlink -f "$a"); \
573                                         # full/relative paths that resolve symlink \
574                                         l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
575                                         l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
576                                         # full paths that do not resolve symlink \
577                                         l=${l#/usr/share/man/}; \
578                                         l=${l#/usr/X11R6/man/}; \
579                                 else \
580                                         l=${a#$RPM_BUILD_ROOT$i/}; \
581                                         l=${l%/*}; \
582                                         l="$l/$m"; \
583                                 fi; \
584                                 rm -f $a; \
585                                 echo ".so $l" > $a; \
586                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
587                         done; \
588                         # verify that .so links point to existing files (not allowed to point to "other package") \
589                         # TODO: iterate over all man dirs, but in Th there is only one true man dir \
590                         err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
591                                 l=$(grep -r '^\.so ' "$doc"); \
592                                 l=${l#.so }; \
593                                 d=$(dirname $doc); \
594                                 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo "  ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
595                         done); \
596                         test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
597                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
598                 fi; \
599         done; \
600         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
601                 echo "Compress info pages: %{_infodir}"; \
602                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
603                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
604                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
605         fi; \
606 }; __spec_install_post_compress_docs } }
607
608 #-----------------------------------------------------------------
609 # Strip executable binaries and shared object files
610 #
611 # Requires: find, awk, strip, cut, xargs
612 #
613 # Special macros which affect this process:
614 #%no_install_post_strip 1               # disable stripping at all
615 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
616 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
617 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
618 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
619 #
620 %__spec_install_post_strip {%{!?debug: \
621 %{!?no_install_post_strip:__spec_install_post_strip() { \
622 %{!?debug:set +x;} \
623 if [ -d "$RPM_BUILD_ROOT" ]; then \
624         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
625                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules \( -name '*.o' -o -name '*.ko' \) -type f -print); \
626                 if [ "$modulelist" ]; then \
627                         modulecount=$(echo "$modulelist" | wc -l); \
628                         printf "Stripping %d kernel modules..." $modulecount; \
629                         echo "$modulelist" | xargs -l512 chmod u+w; \
630                         echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
631                         echo "DONE"; \
632                 fi; \
633         fi; \
634         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[x0-9]*/debug/.*\.debug" ! -regex ".*/usr/lib[x0-9]*.*/guile/.*\.go" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
635         if [ -n "$filelist" ]; then \
636                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
637                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
638                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
639                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
640                 if [ -n "$elfexelist" ]; then \
641                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
642                         echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
643                         echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
644                         echo "DONE"; \
645                 fi; \
646                 if [ -n "$elfsharedlist" ]; then \
647                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
648                         echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
649                         echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
650                         echo "DONE"; \
651                 fi; \
652                 if [ -n "$archiveslist" ]; then \
653                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
654                         echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
655                         echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
656                         echo "DONE"; \
657                 fi; \
658         fi; \
659     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
660     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
661     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
662         if [ -n "$filelist_all" ]; then \
663                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
664                 chmod u+w $filelist_all; \
665                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
666                 echo "DONE"; \
667         fi; \
668         if [ -n "$filelist_unneeded" ]; then \
669                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
670                 chmod u+w $filelist_unneeded; \
671                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
672                 echo "DONE"; \
673         fi; \
674         if [ -n "$filelist_debug" ]; then \
675                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
676                 chmod u+w $filelist_debug; \
677                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
678                 echo "DONE"; \
679         fi; \
680 fi; }; __spec_install_post_strip } } }
681
682 #-----------------------------------------------------------------
683 # remove all RPATH/RUNPATH from executable binaries and shared object files
684 #
685 # Requires: find, awk, cut, xargs, chrpath, uname
686 #
687 # Special macros which affect this process
688 #%no_install_post_chrpath       1       # disable chrpath at all
689 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
690 #
691 %__spec_install_post_chrpath {%{!?debug: \
692 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
693 %{!?debug:set +x;} \
694 if [ -d "$RPM_BUILD_ROOT" ]; then \
695         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
696         if [ -n "$files" ]; then \
697                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
698         fi; \
699         if [ -n "$objs" ]; then \
700                 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
701                 echo "$objs" | \
702                 while read file; do \
703                         rpath= ; \
704                         chmod u+w "$file"; \
705                         for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
706                                         case $dir in \
707                                         '$ORIGIN' ) \
708                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
709                                                 else rpath="$rpath:$dir" ; fi ; \
710                                                 continue ; \
711                                                 ;; \
712                                         esac ; \
713                                         newdir=$(readlink -m "$dir"); \
714                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
715                                         case $dir in \
716                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
717                                                 echo "remove-rpath: $dir in $file"; \
718                                                 ;; \
719                                         * ) \
720                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
721                                                 else rpath="$rpath:$dir" ; fi ; \
722                                                 ;; \
723                                         esac ; \
724                         done ; \
725                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
726                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
727                 done; \
728         fi; \
729 fi; }; __spec_install_post_chrpath } } }
730
731 # vim: "
732
733 #-----------------------------------------------------------------
734 # Find all shared object files with unresolved symbols. Warn
735 # and terminate if any found (termination can be turned off by define).
736 #%no_install_post_check_so 1
737 #%skip_post_check_so libwithunresolvedok.so.*
738 #
739 # NOTE: define skip_post_check_so only if such library really requires
740 #       unresolved symbols and always leave a comment why it is required:
741 #       # executable provides symbols foo, bar for those libraries:
742 #       %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
743 #
744 %__spec_install_post_check_so { \
745 __spec_install_post_check_so() { \
746 %{!?debug:set +x;} \
747         fail=0; \
748         printf "Searching for shared objects with unresolved symbols..."; \
749         for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
750                 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; skip["_ZSt15__once_callable"]=1; skip["_ZSt11__once_call"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
751         done ; \
752         echo " DONE"; \
753         %{!?no_install_post_check_so:return $fail;} \
754 }; __spec_install_post_check_so }}
755
756 #-----------------------------------------------------------------
757 # Find all ELF files with executable stac. Warn and terminate if any found
758 # (termination can be turned off by define).
759 # Details: https://wiki.gentoo.org/wiki/Hardened/GNU_stack_quickstart
760 #%no_install_post_check_stackexec 1
761 #%skip_post_check_stackexec libwithexecstackok.so.*
762 #
763 # NOTE: define skip_post_check_stackexec only if such program or library
764 #       really requires executable stack and always leave a comment why
765 #       it is required:
766 #       # Programs full of nested functions that cannot be fixed
767 #       %define skip_post_check_execstack /bin/foo libwithexecstack.so.*
768 #
769 %__spec_install_post_check_execstack { \
770 __spec_install_post_check_execstack() { \
771 %{!?debug:set +x;} \
772         fail=0; \
773         printf "Searching for ELF programs with executable stack..."; \
774         for f in $(find $RPM_BUILD_ROOT -type f -print) ; do \
775                 LC_ALL=C readelf -lW $f 2>/dev/null | \
776                 LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; } /GNU_STACK/ { if ($7 ~ "E") { found=1 } } END { if (found) { print "\nExecutable stack found in: " file; %{?skip_post_check_execstack:split("%{skip_post_check_execstack}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "File marked with skip_post_check_execstack, ignoring errors.\n"; exit(0); } } } exit(1); } }' || fail=1 ; \
777         done ; \
778         echo " DONE"; \
779         %{!?no_install_post_check_execstack:return $fail;} \
780 }; __spec_install_post_check_execstack }}
781
782 #-----------------------------------------------------------------
783 # Verify that for each directory under /var/run package contains
784 # tmpfiles.d configuration. Warn and terminate build if config is
785 # missing.
786 #
787 #%no_install_post_check_tmpfiles 1
788 #
789 %__spec_install_post_check_tmpfiles { \
790 __spec_install_post_check_tmpfiles() { \
791 %{!?debug:set +x;} \
792         fail=0; \
793         echo "Checking /var/run <-> tmpfiles.d completeness..."; \
794         for d in $RPM_BUILD_ROOT/var/run/*; do \
795                 [ -d "$d" ] || continue; \
796                 d=${d##$RPM_BUILD_ROOT}; \
797                 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
798                         echo "No tmpfiles configuration for '$d'";\
799                         fail=1 ; \
800                 fi \
801         done ; \
802         echo " DONE"; \
803         %{!?no_install_post_check_tmpfiles:return $fail;} \
804 }; __spec_install_post_check_tmpfiles }}
805
806 #-----------------------------------------------------------------
807 # Verify that scripts have reasonable shebangs
808 # Test spec: see "test/spec_install_post_check_shebangs" branch on packages/test.spec
809 #
810 #%no_install_post_check_shebangs 1
811 #
812 %__spec_install_post_check_shebangs { \
813 __spec_install_post_check_shebangs() { \
814 %{!?debug:set +x;} \
815         echo "Checking script shebangs..."; \
816         fail=` \
817         find $RPM_BUILD_ROOT -type f -perm -500 -print | { fail=0; while IFS= read -r f; do \
818                 shebang="$(sed -e'1s/#! *\(.*\)/\1/;t;d;q' "$f")" ; \
819                 f="${f##$RPM_BUILD_ROOT}"; \
820                 case "$shebang" in \
821                         "%{__python}"|"%{__python3}"|"%{__python} "*|"%{__python3} "* \
822                         |"/usr/bin/python%{py_ver}"|"/usr/bin/python%{py_ver} "* \
823                         |"/usr/bin/python%{py3_ver}"|"/usr/bin/python%{py3_ver} "*) \
824                                 ;; \
825                         "/usr/bin/env python"*|"/usr/bin/python"|"/usr/bin/python "*) \
826                                 echo "$f starts with '#!$shebang', should be '#!%{__python}' or '#!%{__python3}'" >&2;\
827                                 fail=1 ; \
828                                 ;; \
829                         "/usr/bin/env "*) \
830                                 echo "$f starts with '#!$shebang', should be explicit interpreter path" >&2;\
831                                 fail=1 ; \
832                                 ;; \
833                         *) ;;\
834                 esac ; \
835         done ; \
836         echo "$fail" ; \
837         }`; \
838         echo " DONE" ; \
839         %{!?no_install_post_check_shebangs:return $fail;} \
840 }; __spec_install_post_check_shebangs }}
841
842 # Remove common Perl files we don't package
843 %__spec_install_post_perl_clean {\
844 %{!?no_install_post_perl_clean: \
845 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
846 } }
847
848 # Helpers to specify SONAME depdendencies, e.g.:
849 #   Requires: %{_soname_prov libfoo.so.1}
850 #   Requires: %{_soname_prov libfoo.so.1(SOME_SYMVER)}
851 #
852 # BuildRequires:        rpmbuild(macros) >= 1.721
853 #
854 %_soname_tag %(echo %{_lib} | sed -e 's/^lib//' -e 's/^\\(.\\+\\)$/(\\1bit)/')
855 %_soname_prov() %(echo "%{1}()%{_soname_tag}" | sed -e 's/^\\([^(]*([^)]\\+)\\)()%{_soname_tag}$/\\1%{_soname_tag}/;s/()$//')
856
857 #-----------------------------------------------------------------
858 # Update GConf2 schemas
859 #
860 # Requires: GConf2
861 #
862 %gconf_schema_install() \
863         umask 022; \
864         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
865         /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
866 %{nil}
867
868 %gconf_schema_uninstall() \
869 if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
870         umask 022; \
871         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
872         /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
873 fi; \
874 %{nil}
875
876 #-----------------------------------------------------------------
877 # Update desktop MIME database
878 # requires: desktop-file-utils
879 %update_desktop_database() {{ \
880         umask 022; \
881         /usr/bin/update-desktop-database -q; \
882 };} \
883 %{nil}
884
885 %update_desktop_database_post %update_desktop_database
886
887 %update_desktop_database_postun() {{ \
888 if [ "$1" = "0" ]; then \
889         %update_desktop_database \
890 fi; \
891 };} \
892 %{nil}
893
894 #-----------------------------------------------------------------
895 # Update shared MIME info database
896 # requires: shared-mime-info
897 # Note: https://bugs.freedesktop.org/show_bug.cgi?id=70366#c19
898 #       https://bugzilla.redhat.com/show_bug.cgi?id=1052173
899 # TODO: if you want this running with fdatasync(), make sure it's:
900 #       1. announcing ~minute delay by echoing appropriate message,
901 #       2. running only once after rpm transaction.
902 #
903 %update_mime_database() {{ \
904         umask 022; \
905         PKGSYSTEM_ENABLE_FSYNC=0 \
906         /usr/bin/update-mime-database %{_datadir}/mime; \
907 };} \
908 %{nil}
909
910 #-----------------------------------------------------------------
911 # Update icon cache
912 # BuildRequires:        rpmbuild(macros) >= 1.596
913 # Requires:             hicolor-icon-theme
914 #
915 %update_icon_cache() {{ \
916         %{!?1:%{error:%{0}: Required theme name missing}} \
917         if [ -x /usr/bin/gtk-update-icon-cache ]; then \
918                 umask 022; \
919                 touch --no-create %{_iconsdir}/%1; \
920                 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
921         fi; \
922 };} \
923 %{nil}
924
925 #-----------------------------------------------------------------
926 # Update scrollkeeper database
927 # requires: scrollkeeper
928 #
929 %scrollkeeper_update_post() \
930         /usr/bin/scrollkeeper-update -q; \
931 %{nil}
932
933 %scrollkeeper_update_postun() \
934 if [ "$1" = "0" ]; then \
935         /usr/bin/scrollkeeper-update -q; \
936 fi; \
937 %{nil}
938
939 #-----------------------------------------------------------------
940 # Compile GSettings schemas
941 # requires: glib2 >= 1:2.26.0
942 #
943 %glib_compile_schemas() {{ \
944         umask 022; \
945         /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
946 };} \
947 %{nil}
948
949 #-----------------------------------------------------------------
950 # post %install sequence:
951 # - autodeps exceptions
952 # - compress all man and info pages,
953 # - strip all ELF executables and ELF shared objects if not %debug.
954 # - compress kernel modules if any
955
956 ###################################################################
957 # Requires/Provides automation
958 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
959 #
960 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
961 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
962 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
963 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov) \
964         %{?_noautoprov: %{_noautoprov}} \
965         %{?_noautoprov_java: %{__noauto_regexp_helper -p java %{_noautoprov_java}}} \
966         %{?_noautoprov_mono: %{__noauto_regexp_helper -p mono %{_noautoprov_mono}}} \
967         %{?_noautoprov_pear: %{__noauto_regexp_helper -p pear %{_noautoprov_pear}}} \
968         %{?_noautoprov_perl: %{__noauto_regexp_helper -p perl %{_noautoprov_perl}}} \
969         %{?_noautoprov_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoprov_pyegg}}} \
970         %{?_noautoprov_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoprov_py3egg}}} \
971         %{nil}
972 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
973         %{?_noautoreq: %{_noautoreq}} \
974         %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
975         %{?_noautoreq_mono: %{__noauto_regexp_helper -p mono %{_noautoreq_mono}}} \
976         %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
977         %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
978         %{?_noautoreq_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoreq_pyegg}}} \
979         %{?_noautoreq_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoreq_py3egg}}} \
980         %{nil}
981
982 # helper for wrapping _noautoreq between perl() or pear()
983 # Author: Elan Ruusamäe <glen@pld-linux.org>
984 # Usage:
985 # BuildRequires:        rpmbuild(macros) >= 1.654
986 # %define _noautoreq_pear Excluded.php PEAR/Something.php
987 # %define _noautoreq_perl Apache::.*
988 # BuildRequires:        rpmbuild(macros) >= 1.672
989 # %define _noautoreq_java ClassDataVersion
990 # BuildRequires:        rpmbuild(macros) >= 1.709
991 # %define _noautoreq_pyegg argparse
992 # %define _noautoreq_py3egg backports.ssl-match-hostname ipaddress
993 # BuildRequires:        rpmbuild(macros) >= 1.730
994 # %define _noautoreq_mono Gendarme.Framework
995 # BuildRequires:        rpmbuild(macros) >= 1.737
996 # %define _noautoprov_java Class
997 # %define _noautoprov_mono Excluded.Provide
998 # %define _noautoprov_pear Excluded.php
999 # %define _noautoprov_perl Excluded::Module
1000 # %define _noautoprov_pyegg excluded
1001 # %define _noautoprov_py3egg excluded3
1002 #
1003 %__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}%{__qchar}(%%s%{__qchar}) ", $1)}')
1004 # detect quote character runtime
1005 %__qchar_4 \\\\%{nil}
1006 %__qchar_5 \\\\\\%{nil}
1007 %__qchar %{expand:%%global __qchar %%__qchar_%(echo %{_rpmversion} | cut -c1)}%__qchar
1008
1009 #%_noautocompressdoc    %{nil}
1010 #
1011 %_missing_doc_files_terminate_build     1%{nil}
1012 %_unpackaged_files_terminate_build      %{nil}
1013
1014 # node.js libdir
1015 # Requirements:
1016 # BuildRequires: rpmbuild(macros) >= 1.634
1017 %nodejs_libdir          /usr/lib/node_modules
1018
1019 # bash-completion 2.0 completions dir
1020 # Requirements:
1021 # BuildRequires:        rpmbuild(macros) >= 1.673
1022 # Requires:     bash-completion >= 2.0
1023 %bash_compdir           /usr/share/bash-completion/completions
1024
1025 # fish completions dir
1026 # Requirements:
1027 # BuildRequires:        rpmbuild(macros) >= 1.720
1028 %fish_compdir           /usr/share/fish/vendor_completions.d
1029
1030 # zsh completions dir
1031 # Requirements:
1032 # BuildRequires:        rpmbuild(macros) >= 1.719
1033 %zsh_compdir            /usr/share/zsh/site-functions
1034
1035 # depmod macro
1036 %depmod() { \
1037 umask 022; \
1038 if [ -e /boot/System.map-%1 ]; then \
1039         /sbin/depmod -a -F /boot/System.map-%1 %1; \
1040 else \
1041         if [ -e /boot/System.map ]; then \
1042                 /sbin/depmod -a -F /boot/System.map %1; \
1043         else \
1044                 /sbin/depmod -a %1; \
1045         fi \
1046 fi; \
1047 }
1048
1049 # user/group checking macros
1050 #
1051 # Usage:
1052 #       %userremove myuser
1053 #
1054 %userremove     /usr/lib/rpm/user_group.sh user del
1055 %groupremove    /usr/lib/rpm/user_group.sh group del
1056 #
1057 # Usage:
1058 #       if %usertestrm myuser; then
1059 #               /usr/sbin/userdel -r myuser
1060 # Note:
1061 #       use these macros only if you need to call userdel/groupdel with
1062 #       a non-standard option or take an extra action; otherwise use the
1063 #       %userremove/%groupremove macros
1064 #
1065 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
1066 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
1067 # user group membership management macros
1068 #
1069 # Usage:
1070 #       %addusertogroup [-q] myuser agroup
1071 #
1072 #  -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1073 #
1074 # Requirements:
1075 # BuildRequires:        rpmbuild(macros) >= 1.515
1076 %addusertogroup(q)      quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1077 %{nil}
1078
1079 # banner support (useful in {pre,post}{,un} and triggers)
1080 #
1081 # Usage:
1082 #       %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1083 # the banner text, the banner text
1084 # the banner text, and following line
1085 #EOF
1086 # You can use any form of here-document, <<'EOF' <<-EOT will do.
1087 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1088 #
1089 # -a    - append to the banner
1090 # -e    - send to stderr instead of stdout
1091 # -n    - don't show banner (overrides -t)
1092 # -t    - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1093 # -o    - show only once, i.e when package is installed for the first time
1094 #
1095 # Tests:
1096 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1097 # (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1098 # (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1099 # rpm -E 'date | %banner -e banner' > m; sh -x m
1100 # rpm -E 'date | %banner -o -e banner' > m; sh -x m
1101 #
1102 %banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1103 RPM_SCRIPTVERBOSITY=5 \
1104 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1105 if [ -x /usr/bin/banner.sh ]; then \
1106         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1107 else \
1108         CMD="cat%{-e: >&2}" \
1109 fi \
1110 eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1111 %{nil}
1112
1113 # useradd/groupadd macros
1114 # Author: Elan Ruusamäe <glen@pld-linux.org>
1115 #
1116 # Usage:
1117 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1118 #   [-g initial_group] [-G group[,...]] login
1119 #
1120 #  -u uid. REQUIRED
1121 #  -g gid/group. REQUIRED
1122 #  -s defaults to /bin/false
1123 #  -d defaults to /usr/share/empty
1124 #  -c No default
1125 #  -r is accepted but ignored (it's always set)
1126 #  -k skeleton dir. defaults to /usr/share/empty
1127 # rpm specific flags
1128 #  -P package name. defaults to %{name}
1129 #
1130 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1131 %{!-u:%{error:useradd: Required argument -u missing}} \
1132 %{!-g:%{error:useradd: Required argument -g missing}} \
1133 %{!?1:%{error:useradd: Required parameter login missing}} \
1134 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1135         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1136                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1137                 exit 1 \
1138         fi \
1139 else \
1140         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1141         /usr/sbin/useradd \\\
1142                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1143                 -u %{-u*} \\\
1144                 -r \\\
1145                 -d %{-d*}%{!-d:/usr/share/empty} \\\
1146                 -s %{-s*}%{!-s:/bin/false} \\\
1147                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1148                 -g %{-g*} \\\
1149                 %{-M} \\\
1150                 %{-G:-G %{-G*}} \\\
1151                 %{expand:%{%{#}}} 1>&2 || exit $? \
1152         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1153 fi;
1154 # vim: "
1155
1156 # Usage:
1157 #   %groupadd [-P package] [-g gid] group
1158 #
1159 # -g gid. REQUIRED
1160 #
1161 # Sample:
1162 #   %groupadd -P %{name}-base -g %{gid} %{name}
1163
1164 %groupadd(g:P:rfo)      \
1165 %{!-g:%{error:groupadd: Required argument -g missing}} \
1166 %{!?1:%{error:groupadd: Required parameter group missing}} \
1167 if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1168         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1169                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1170                 exit 1 \
1171         fi \
1172 else \
1173         echo "Adding group %{1} GID=%{-g*}." \
1174         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1175         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1176 fi;
1177
1178 # service macro.
1179 # Author: Elan Ruusamäe <glen@pld-linux.org>
1180 #
1181 # calls usual service restart on package %post, but skips the restart if
1182 # administrator has disabled automatic service restarts in either global
1183 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1184 # NOTE: systemd_booted machines do not print
1185 #               Run "{command}" to restart {service}.
1186 # message for packages without native systemd unit (not here, no %systemd_post).
1187 #
1188 # Usage:
1189 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1190 #
1191 #  -q be silent when service isn't started (for scriplets restaring other package's services)
1192 #  -n NOOP mode, do not actually restart service
1193 #
1194 # Requirements:
1195 # BuildRequires:        rpmbuild(macros) >= 1.268
1196 # Requires:     rc-scripts
1197 # -n option:
1198 # BuildRequires:        rpmbuild(macros) >= 1.450
1199 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1200
1201 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1202
1203 # patchset macros
1204 # generate SourceX urls from range START STOP
1205 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1206 # The sources start from 10000
1207 #
1208 # Author: Elan Ruusamäe <glen@pld-linux.org>
1209 #
1210 # Usage:
1211 #   %patchset_source -f <seq(1) format> <start> [<end>]
1212 #   %patchset_patch <start> [<end>]
1213 # If <end> is omited, it is assumed to be <start>.
1214 #
1215 # For example in preamble:
1216 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1217 # and in %prep:
1218 #  %patchset_patch 33 44
1219 #
1220 # Using sources list:
1221 #   BuildRequires:      rpmbuild(macros) >= 1.426
1222 #   %patchset_source -f <url> -s <filelist>
1223 #   %patchset_patch -s <filelist>
1224 # For example (ncurses):
1225 #   BuildRequires:      rpmbuild(macros) >= 1.683
1226 #   %patchset_source -f ftp://dickey.his.com/ncurses/%{basever}/ -s sources
1227 #   %patchset_patch -s sources -p1
1228 #
1229
1230 %patchset_source(f:b:s:) %(
1231         base=%{-b*}%{!-b*:10000}
1232 %{-s:
1233         baseurl='%{-f*}'
1234         filelist='%{-s*}'
1235         i=$base
1236         while read checksum file; do
1237                 printf "Patch%d: %s%s\\n" $i "$baseurl" "$file"
1238                 i=$((i+1))
1239         done < $filelist
1240 }
1241 %{!-s:
1242         start=$(expr $base + %1);
1243         end=$(expr $base + %{?2}%{!?2:%{1}});
1244         # we need to call seq twice as it doesn't allow two formats
1245         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1246         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1247         paste %{tmpdir}/__ps{1,2};
1248         rm -f %{tmpdir}/__ps{1,2};
1249 }
1250 ) \
1251 %{nil}
1252
1253 # apply sources from %patchset_source
1254 # -p specify -pX for %patch line
1255 # -b base offset: defaults to 10000
1256 # -s filelist to read files from
1257 %patchset_patch(f:p:b:s:) %(
1258         base=%{-b*}%{!-b*:10000}
1259         patchlevel=%{-p*:-p%{-p*}}
1260 %{-s:
1261         filelist='%{-s*}'
1262         i=$base
1263         while read checksum file; do
1264                 printf "patch%d %s\\n" $i "$patchlevel" | sed -e s,^,%%,
1265                 i=$((i+1))
1266         done < $filelist
1267 }
1268 %{!-s:
1269         start=$(expr $base + %1);
1270         end=$(expr $base + %{?2}%{!?2:%{1}});
1271         echo ": patchset_patch %1%{?2: to %2}";
1272         seq -f "patch%g $patchlevel" $start $end | sed -e s,^,%%,;
1273 }
1274 ) \
1275 %{nil}
1276
1277 # return EXPANDED source url N from current spec
1278 %sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1279
1280 # Helper for LUA.
1281 # split string separated by space into quoted list
1282 #
1283 # Author: Elan Ruusamäe <glen@pld-linux.org>
1284 #
1285 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1286 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1287
1288 # adjust /etc/shells by adding and removing shells from there
1289 # Author: Elan Ruusamäe <glen@pld-linux.org>
1290 #
1291 # Usage:
1292 #   %post       -p <lua>
1293 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1294 #
1295 #   %preun      -p <lua>
1296 #   if arg[2] == 0 then
1297 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1298 #   end
1299 #
1300 # Requirements:
1301 # BuildRequires:        rpmbuild(macros) >= 1.462
1302 #
1303
1304 %lua_add_etc_shells() \
1305 t = {}\
1306 f = io.open("/etc/shells", "r")\
1307 if f then\
1308         for l in f:lines() do t[l]=l; end\
1309         f:close()\
1310 end\
1311 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1312         if not t[s] then\
1313                 print("Adding "..s.." to /etc/shells")\
1314                 f = io.open("/etc/shells", "a")\
1315                 if f then\
1316                         f:write(s.."\\n")\
1317                         f:close()\
1318                 end\
1319         end\
1320 end\
1321 %{nil}
1322
1323 %lua_remove_etc_shells() \
1324 t = {}\
1325 f = io.open("/etc/shells", "r")\
1326 if f then\
1327         for l in f:lines() do t[l]=l; end\
1328         f:close()\
1329 end\
1330 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1331         print("Removing "..l.." from /etc/shells")\
1332         t[l] = nil\
1333 end\
1334 s=""\
1335 for _, l in pairs(t) do\
1336         s=s..l.."\\n"\
1337 end\
1338 f = io.open("/etc/shells", "w")\
1339 if f then\
1340         f:write(s)\
1341         f:close()\
1342 end\
1343 %{nil}
1344
1345 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1346 #
1347 # Author: Elan Ruusamäe <glen@pld-linux.org>
1348 #
1349 # Usage:
1350 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1351 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1352 #
1353 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1354 #
1355 # Requirements:
1356 # BuildRequires:        rpmbuild(macros) >= 1.429
1357 #
1358 %add_etc_shells(p) %{-p:<lua>}\
1359 %{expand:%%lua_add_etc_shells %*}\
1360 %{nil}
1361
1362 %remove_etc_shells(p) %{-p:<lua>}\
1363 %{-p:if arg[2] == 0 then}\
1364 %{expand:%%lua_remove_etc_shells %*}\
1365 %{-p:end} \
1366 %{nil}
1367
1368 # Undos files
1369 #
1370 # Author: Paweł Zuzelski <pawelz@pld-linux.org>
1371 # Author: Elan Ruusamäe <glen@pld-linux.org>
1372 #
1373 # Usage:
1374 #   %undos list_of_files
1375 #   %undos -f EXT[,EXT]
1376 #   %undos -i -f EXT[,EXT]
1377 #
1378 #  -f EXT[,EXT] - find(1) files by extensions
1379 #  -i - case insensitive file search
1380 #
1381 # Example:
1382 #   Un-DOS all *.js, *.css files
1383 #   %undos -f js,css
1384 #   Un-DOS all *.js, *.JS files
1385 #   %undos -f js -i
1386 #   undos all Makefiles
1387 #   %{__find} -name Makefile | xargs %undos
1388 #
1389 # Requirements:
1390 # BuildRequires:        sed >= 4.0
1391 # BuildRequires:        rpmbuild(macros) >= 1.674
1392
1393 # NB: make sure this macro stays on one line
1394 # NB: make sure it includes newline escape
1395 %undos(f:i)     %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1396 %{nil}
1397
1398 #-----------------------------------------------------------------
1399 # Update hardware database index
1400 #
1401 # Requirements:
1402 # BuildRequires:        rpmbuild(macros) >= 1.691
1403 # Requires:             udev-core >= 1:196
1404
1405 %udev_hwdb_update() \
1406 /sbin/udevadm hwdb --update >/dev/null 2>&1 || : \
1407 %{nil}
1408
1409 # Generate vim help tags file
1410 #
1411 # Requirements:
1412 # BuildRequires:        rpmbuild(macros) >= 1.718
1413 # Requires(post,postun):        /usr/bin/vim
1414 # Requires(post,postun):        vim-rt >= 4:7.4.2054-2
1415 %vim_doc_helptags() \
1416 umask 022; \
1417 /usr/bin/vim -c ':helptags /usr/share/vim/doc' -c ':q' 2>/dev/null \
1418 %{nil}
1419
1420 # EOF
This page took 0.130972 seconds and 2 git commands to generate.